<?php

/**
 * Entity metadata controller.
 *
 * Registers the properties declared in $entity_info['property map'].
 */
class RemoteEntityAPIDefaultMetadataController extends EntityDefaultMetadataController {

  public function entityPropertyInfo() {
    // Let the parent class handle the schema properties.
    $parent_info = parent::entityPropertyInfo();

    // This is so awkward I am surely doing it wrong :/
    $properties = $parent_info[$this->type]['properties'];

    // Basic entity keys.
    foreach ($this->info['remote entity keys'] as $entity_key => $remote_key) {
      $properties[$entity_key] = array(
        'label' => $entity_key,
        'description' => t("An entity key property."),
        'type' => 'text',
        'getter callback' => 'remote_entity_entity_key_property_get',
      );
    }    
    
    // Properties from the property map.
    foreach ($this->info['property map'] as $property => $remote_property) {
      $properties[$property] = array(
        'label' => $property,
        'description' => t("A remote property."),
        'type' => 'text',
        'getter callback' => 'remote_entity_entity_mapped_property_get',
        'setter callback' => 'remote_entity_entity_mapped_property_set',
        // Custom property to helper our getters and setters.
        'remote_property' => $remote_property,
      );
    }

    $info = array();
    $info[$this->type]['properties'] = $properties;

    return $info;
  }

}
